git-am support for naked email messages (take 2)
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 #
4 . git-sh-setup
5
6 usage () {
7     echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>"
8     echo >&2 "  or, when resuming"
9     echo >&2 "  $0 [--skip | --resolved]"
10     exit 1;
11 }
12
13 stop_here () {
14     echo "$1" >"$dotest/next"
15     exit 1
16 }
17
18 go_next () {
19         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
20                 "$dotest/patch" "$dotest/info"
21         echo "$next" >"$dotest/next"
22         this=$next
23 }
24
25 fall_back_3way () {
26     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
27
28     rm -fr "$dotest"/patch-merge-*
29     mkdir "$dotest/patch-merge-tmp-dir"
30
31     # First see if the patch records the index info that we can use.
32     if git-apply -z --index-info "$dotest/patch" \
33         >"$dotest/patch-merge-index-info" 2>/dev/null &&
34         GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
35         git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
36         GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
37         git-write-tree >"$dotest/patch-merge-base+" &&
38         # index has the base tree now.
39         (
40             cd "$dotest/patch-merge-tmp-dir" &&
41             GIT_INDEX_FILE="../patch-merge-tmp-index" \
42             GIT_OBJECT_DIRECTORY="$O_OBJECT" \
43             git-apply $binary --index <../patch
44         )
45     then
46         echo Using index info to reconstruct a base tree...
47         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
48         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
49     else
50         # Otherwise, try nearby trees that can be used to apply the
51         # patch.
52         (
53             N=10
54
55             # Hoping the patch is against our recent commits...
56             git-rev-list --max-count=$N HEAD
57
58             # or hoping the patch is against known tags...
59             git-ls-remote --tags .
60         ) |
61         while read base junk
62         do
63             # See if we have it as a tree...
64             git-cat-file tree "$base" >/dev/null 2>&1 || continue
65
66             rm -fr "$dotest"/patch-merge-* &&
67             mkdir "$dotest/patch-merge-tmp-dir" || break
68             (
69                 cd "$dotest/patch-merge-tmp-dir" &&
70                 GIT_INDEX_FILE=../patch-merge-tmp-index &&
71                 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
72                 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
73                 git-read-tree "$base" &&
74                 git-apply $binary --index &&
75                 mv ../patch-merge-tmp-index ../patch-merge-index &&
76                 echo "$base" >../patch-merge-base
77             ) <"$dotest/patch"  2>/dev/null && break
78         done
79     fi
80
81     test -f "$dotest/patch-merge-index" &&
82     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
83     orig_tree=$(cat "$dotest/patch-merge-base") &&
84     rm -fr "$dotest"/patch-merge-* || exit 1
85
86     echo Falling back to patching base and 3-way merge...
87
88     # This is not so wrong.  Depending on which base we picked,
89     # orig_tree may be wildly different from ours, but his_tree
90     # has the same set of wildly different changes in parts the
91     # patch did not touch, so resolve ends up cancelling them,
92     # saying that we reverted all those changes.
93
94     git-merge-resolve $orig_tree -- HEAD $his_tree || {
95             echo Failed to merge in the changes.
96             exit 1
97     }
98 }
99
100 prec=4
101 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
102
103 while case "$#" in 0) break;; esac
104 do
105         case "$1" in
106         -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
107         dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
108         -d|--d|--do|--dot|--dote|--dotes|--dotest)
109         case "$#" in 1) usage ;; esac; shift
110         dotest="$1"; shift;;
111
112         -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
113         --interacti|--interactiv|--interactive)
114         interactive=t; shift ;;
115
116         -b|--b|--bi|--bin|--bina|--binar|--binary)
117         binary=t; shift ;;
118
119         -3|--3|--3w|--3wa|--3way)
120         threeway=t; shift ;;
121         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
122         sign=t; shift ;;
123         -u|--u|--ut|--utf|--utf8)
124         utf8=t; shift ;;
125         -k|--k|--ke|--kee|--keep)
126         keep=t; shift ;;
127
128         -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
129         resolved=t; shift ;;
130
131         --sk|--ski|--skip)
132         skip=t; shift ;;
133
134         --)
135         shift; break ;;
136         -*)
137         usage ;;
138         *)
139         break ;;
140         esac
141 done
142
143 # If the dotest directory exists, but we have finished applying all the
144 # patches in them, clear it out.
145 if test -d "$dotest" &&
146    last=$(cat "$dotest/last") &&
147    next=$(cat "$dotest/next") &&
148    test $# != 0 &&
149    test "$next" -gt "$last"
150 then
151    rm -fr "$dotest"
152 fi
153
154 if test -d "$dotest"
155 then
156         test ",$#," = ",0," ||
157         die "previous dotest directory $dotest still exists but mbox given."
158         resume=yes
159 else
160         # Make sure we are not given --skip nor --resolved
161         test ",$skip,$resolved," = ,,, ||
162                 die "we are not resuming."
163
164         # Start afresh.
165         mkdir -p "$dotest" || exit
166
167         git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
168                 rm -fr "$dotest"
169                 exit 1
170         }
171
172         # -b, -s, -u and -k flags are kept for the resuming session after
173         # a patch failure.
174         # -3 and -i can and must be given when resuming.
175         echo "$binary" >"$dotest/binary"
176         echo "$sign" >"$dotest/sign"
177         echo "$utf8" >"$dotest/utf8"
178         echo "$keep" >"$dotest/keep"
179         echo 1 >"$dotest/next"
180 fi
181
182 case "$resolved" in
183 '')
184         files=$(git-diff-index --cached --name-only HEAD) || exit
185         if [ "$files" ]; then
186            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
187            exit 1
188         fi
189 esac
190
191 if test "$(cat "$dotest/binary")" = t
192 then
193         binary=--allow-binary-replacement
194 fi
195 if test "$(cat "$dotest/utf8")" = t
196 then
197         utf8=-u
198 fi
199 if test "$(cat "$dotest/keep")" = t
200 then
201         keep=-k
202 fi
203 if test "$(cat "$dotest/sign")" = t
204 then
205         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
206                         s/>.*/>/
207                         s/^/Signed-off-by: /'
208                 `
209 else
210         SIGNOFF=
211 fi
212
213 last=`cat "$dotest/last"`
214 this=`cat "$dotest/next"`
215 if test "$skip" = t
216 then
217         this=`expr "$this" + 1`
218 fi
219
220 if test "$this" -gt "$last"
221 then
222         echo Nothing to do.
223         rm -fr "$dotest"
224         exit
225 fi
226
227 while test "$this" -le "$last"
228 do
229         msgnum=`printf "%0${prec}d" $this`
230         next=`expr "$this" + 1`
231         test -f "$dotest/$msgnum" || {
232                 go_next
233                 continue
234         }
235
236         # If we are not resuming, parse and extract the patch information
237         # into separate files:
238         #  - info records the authorship and title
239         #  - msg is the rest of commit log message
240         #  - patch is the patch body.
241         #
242         # When we are resuming, these files are either already prepared
243         # by the user, or the user can tell us to do so by --resolved flag.
244         case "$resume" in
245         '')
246                 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
247                         <"$dotest/$msgnum" >"$dotest/info" ||
248                         stop_here $this
249                 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
250                 ;;
251         esac
252
253         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
254         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
255         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
256         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
257
258         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
259         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
260
261         case "$resume" in
262         '')
263             if test '' != "$SIGNOFF"
264             then
265                 LAST_SIGNED_OFF_BY=`
266                     sed -ne '/^Signed-off-by: /p' \
267                     "$dotest/msg-clean" |
268                     tail -n 1
269                 `
270                 ADD_SIGNOFF=`
271                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
272                     test '' = "$LAST_SIGNED_OFF_BY" && echo
273                     echo "$SIGNOFF"
274                 }`
275             else
276                 ADD_SIGNOFF=
277             fi
278             {
279                 echo "$SUBJECT"
280                 if test -s "$dotest/msg-clean"
281                 then
282                         echo
283                         cat "$dotest/msg-clean"
284                 fi
285                 if test '' != "$ADD_SIGNOFF"
286                 then
287                         echo "$ADD_SIGNOFF"
288                 fi
289             } >"$dotest/final-commit"
290             ;;
291         *)
292                 case "$resolved,$interactive" in
293                 tt)
294                         # This is used only for interactive view option.
295                         git-diff-index -p --cached HEAD >"$dotest/patch"
296                         ;;
297                 esac
298         esac
299
300         resume=
301         if test "$interactive" = t
302         then
303             test -t 0 ||
304             die "cannot be interactive without stdin connected to a terminal."
305             action=again
306             while test "$action" = again
307             do
308                 echo "Commit Body is:"
309                 echo "--------------------------"
310                 cat "$dotest/final-commit"
311                 echo "--------------------------"
312                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
313                 read reply
314                 case "$reply" in
315                 [yY]*) action=yes ;;
316                 [aA]*) action=yes interactive= ;;
317                 [nN]*) action=skip ;;
318                 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
319                        action=again ;;
320                 [vV]*) action=again
321                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
322                 *)     action=again ;;
323                 esac
324             done
325         else
326             action=yes
327         fi
328
329         if test $action = skip
330         then
331                 go_next
332                 continue
333         fi
334
335         if test -x "$GIT_DIR"/hooks/applypatch-msg
336         then
337                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
338                 stop_here $this
339         fi
340
341         echo
342         echo "Applying '$SUBJECT'"
343         echo
344
345         case "$resolved" in
346         '')
347                 git-apply $binary --index "$dotest/patch"
348                 apply_status=$?
349                 ;;
350         t)
351                 # Resolved means the user did all the hard work, and
352                 # we do not have to do any patch application.  Just
353                 # trust what the user has in the index file and the
354                 # working tree.
355                 resolved=
356                 apply_status=0
357                 ;;
358         esac
359
360         if test $apply_status = 1 && test "$threeway" = t
361         then
362                 if (fall_back_3way)
363                 then
364                     # Applying the patch to an earlier tree and merging the
365                     # result may have produced the same tree as ours.
366                     changed="$(git-diff-index --cached --name-only -z HEAD)"
367                     if test '' = "$changed"
368                     then
369                             echo No changes -- Patch already applied.
370                             go_next
371                             continue
372                     fi
373                     # clear apply_status -- we have successfully merged.
374                     apply_status=0
375                 fi
376         fi
377         if test $apply_status != 0
378         then
379                 echo Patch failed at $msgnum.
380                 stop_here $this
381         fi
382
383         if test -x "$GIT_DIR"/hooks/pre-applypatch
384         then
385                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
386         fi
387
388         tree=$(git-write-tree) &&
389         echo Wrote tree $tree &&
390         parent=$(git-rev-parse --verify HEAD) &&
391         commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
392         echo Committed: $commit &&
393         git-update-ref HEAD $commit $parent ||
394         stop_here $this
395
396         if test -x "$GIT_DIR"/hooks/post-applypatch
397         then
398                 "$GIT_DIR"/hooks/post-applypatch
399         fi
400
401         go_next
402 done
403
404 rm -fr "$dotest"